"""
Here, we illustrate the usage of a dictionary comprehension, in a common case: create a reverse index dictionary.

We have a list of words, and we want to quickly know the index of a word in the list.
"""

import doctest
from typing import Dict, List

from utils import compare_function_performances


def reverse_word_indices(sentence: List[str]) -> Dict[str, int]:
    """
    Given a list of words, return the dictionary d such as d[word] is the index of word in the list.

    hint: You should use https://docs.python.org/3/library/functions.html#enumerate

    >>> reverse_word_indices(['On', 'va', 'casser', 'du', 'chinois', '!'])
    {'On': 0, 'va': 1, 'casser': 2, 'du': 3, 'chinois': 4, '!': 5}
    >>> reverse_word_indices([])
    {}
    """
    # TODO
    return {}


def reverse_word_indices_naive(sentence: List[str]) -> Dict[str, int]:
    """
    >>> reverse_word_indices(['On', 'va', 'casser', 'du', 'chinois', '!'])
    {'On': 0, 'va': 1, 'casser': 2, 'du': 3, 'chinois': 4, '!': 5}
    >>> reverse_word_indices([])
    {}
    """
    word2index = {}
    for index, word in enumerate(sentence):
        word2index[word] = index
    return word2index


if __name__ == '__main__':
    print(doctest.testmod())
    _sentence = 'NAUIBUiewbflwbfclhsabibwacbueiqhfeklhuhbkfbewk.fjcbfiubewijbvuejbvn/aslkhf;o.wjhaenvoiejbnvoierjkbvmcshfkljc,sm.hvncijklebm,cdhnkfjlbem,fhnerkhbjnsadmhfnoikhsnm'
    compare_function_performances(reverse_word_indices, reverse_word_indices_naive, n_executions=10000, sentence=_sentence)
