"""
In this example, we want to find the reverse operation of zip, `unzip`
The idea is that we have a list of tuples, and we want to retrieve our tuple of lists

Hint: See how to unpack argument lists https://docs.python.org/dev/tutorial/controlflow.html#unpacking-argument-lists
"""

import doctest
from typing import List, Tuple


def unzip(zipped_lists):
    """
    >>> image_names, probabilities = ['cat01.png', 'cat02.png', 'dog01.png', 'dog02.png'], [0.9, 0.4, 0.1, 0.6]
    >>> image_names2, probabilities2 = unzip(zip(image_names, probabilities))
    >>> image_names2, probabilities2
    (('cat01.png', 'cat02.png', 'dog01.png', 'dog02.png'), (0.9, 0.4, 0.1, 0.6))
    >>> image_names == list(image_names2) and probabilities == list(probabilities2)
    True
    """
    return ()


def sort_images(image_names: List[str], probabilities: List[float], threshold: float = 0.5) -> Tuple[Tuple, Tuple]:
    """
    Using the unzip function, and the same idea as in ex2, can you make this sorting function ?
    You should sort the names according to the probabilities, and return the two sorted lists

    Hint: Use the sorted function https://docs.python.org/3/library/functions.html#sorted

    >>> image_names, probabilities = ['cat01.png', 'cat02.png', 'dog01.png', 'dog02.png'], [0.9, 0.4, 0.1, 0.6]
    >>> sort_images(image_names, probabilities)
    (('cat01.png', 'dog02.png', 'cat02.png', dog01.png'), (0.9, 0.6, 0.4, 0.1))
    """
    return ((), ())


if __name__ == '__main__':
    print(doctest.testmod())
