# Zip

It transforms a tuple of lists into a list of tuples, containing the items of the lists given as argument.

## Syntax

```python
zip(list1, list2, list3, ...)
```

## /!\ Be careful that

 - It doesn't return a list, it returns an object that can be iterated; use list(zip(...)) to have a list
 - If your lists doesn't have the same size, it will stop at the shortest one

## Examples

### Ex 1
```python

indices = [1, 2, 3, 4]
names = ['Paul', 'Marc', 'Jean', 'Claudine']
ages = [33, 45, 11, 23]

list(zip(indices, names)) == [(1, 'Paul', 33), (2, 'Marc', 45), (3, 'Jean', 11), (4, 'Claudine', 23)]
```

### Ex 2

See [./00_display.py] to test that code:

```python
def print_image_with_proba(image_names: List[str], probabilities: List[float]) -> None:
    for image_name, proba in zip(image_names, probabilities):
        print(f' - {image_name} has a proba of {proba} to be a cat')
```

## Pros

 - No need of an `indice` variable, when looping over multiple lists;
 - Less code to do the same thing;
 - pythonic
 
## More information

See [python doc](https://docs.python.org/3.3/library/functions.html#zip)
