"""
In the data/ folder, there are 2 sub-folders: cats/ and dogs/

The goal is to get all the filenames of a given category, without the extension.
You shouldn't return the non image files.
You can use the glob function for that: https://docs.python.org/3/library/pathlib.html#pathlib.Path.glob

>>> [*sorted(get_filenames(get_data_dir(), 'cats'))]
['cat01', 'cat02', 'cat03']

>>> [*sorted(get_filenames(get_data_dir(), 'dogs'))]
['dog01', 'dog02']
"""

import doctest
from pathlib import Path
from typing import List


def get_data_dir() -> Path:
    """
    :return: The Path object that leads to the data/ folder
    """
    # TODO
    return Path('.')


def get_filenames(data_dir: Path, category: str) -> List[str]:
    """
    :param data_dir: The Path to the data directory, as returned by yout get_data_dir function
    :param category: The category ('cats' or 'dogs') to read
    :return: The list of filenames (without the extension) of the category
    """
    # TODO
    return []


if __name__ == '__main__':
    print(doctest.testmod())
