from dataclasses import dataclass, field
from typing import List


@dataclass
class Stock:
    products: List[str] = field(default_factory=list)

    def add_to_stock(self, product: str):
        self.products.append(product)


class BadStock:
    def __init__(self, products: List[str] = []):
        self.products: List[str] = products

    def add_to_stock(self, product: str):
        self.products.append(product)


if __name__ == '__main__':
    # Using the default factory
    stock1 = Stock()
    stock2 = Stock()

    stock1.add_to_stock('peper')
    stock2.add_to_stock('salt')

    print(stock2.products)
    print(stock1.products)

    # Using the default argument
    bad_stock1 = BadStock()
    bad_stock2 = BadStock()

    bad_stock1.add_to_stock('peper')
    bad_stock2.add_to_stock('salt')

    print(bad_stock2.products)
    print(bad_stock1.products)
    print(bad_stock1.products is bad_stock2.products)
