from dataclasses import dataclass, InitVar
from typing import ClassVar


@dataclass
class Time:
    hour: int
    min: int = 0
    sec: int = 0

    time_zone: InitVar[int] = 0

    FORMAT: ClassVar[int] = 12  # 12 or 24 ?

    def __post_init__(self, time_zone: int):
        self.hour = (self.hour + time_zone) % self.FORMAT


if __name__ == '__main__':
    print(Time(3, 24, 54, time_zone=6))
    print(Time(13, 66))

    assert Time(5, 23, 0, 2) == Time(7, 23)

    Time.FORMAT = 24
    t = Time(13)

    print(t.FORMAT)
    print(t)
