"""
In this example, we want to illustrate the facility of usage of the dataclass.

Define an `Image` class to handle an image. It should take 2 arguments: the filename and the probability that it is a cat.
It should fix the following:

>>> dog1 = Image('dog01.png', 0.1)
>>> dog2 = Image('dog02.png', 0.6)
>>> cat1 = Image('cat01.png', 0.9)
>>> cat2 = Image('cat02.png', 0.4)

Then, look at the filter_images function.
As usual, we want to keep only the images for which the prediction was above the threshold.
You should be able to fix the 4 following tests, using the things we saw in the previous chapters.

>>> filter_images([cat1, cat2, dog1, dog2]) == [cat1, dog2]
True
>>> filter_images([cat1, cat2, dog1, dog2], 0.4) == [cat1, cat2, dog2]
True
>>> filter_images([cat1, cat2, dog1, dog2], 0.7) == [cat1]
True
>>> filter_images([])
[]

Here, I want to illustrate the use of the post init function.
Back to your `Image` class, you should set the true_label attribute of the Image to 'cat' if the file_path attribute starts with 'cat', and to 'dog' otherwise.

>>> cat1.true_label
'cat'
>>> cat2.true_label
'cat'
>>> dog1.true_label
'dog'
>>> dog2.true_label
'dog'
"""
import doctest
from dataclasses import dataclass
from typing import List


@dataclass
class Image:
    # TODO
    pass


def filter_images(images: List[Image], threshold: float = 0.5) -> List[Image]:
    """
    Filter the images that have a probability greater than the threshold
    """
    # TODO
    return []


if __name__ == '__main__':
    print(doctest.testmod())
