from timeit import timeit
from typing import Callable


_YOUR_METHOD = None
_NAIVE_METHOD = None
_DATA = None


def compare_function_performances(your_method: Callable, naive_method: Callable, n_executions: int, **data):
    global _YOUR_METHOD, _NAIVE_METHOD, _DATA
    _YOUR_METHOD, _NAIVE_METHOD, _DATA = your_method, naive_method, data
    t1 = timeit("_YOUR_METHOD(**_DATA)", setup='from utils import _YOUR_METHOD, _DATA', number=n_executions)
    t2 = timeit("_NAIVE_METHOD(**_DATA)", setup='from utils import _NAIVE_METHOD, _DATA', number=n_executions)

    print(f'Your method takes {100 * t1 / t2:.2f}% of the time of the naive method, over {n_executions} executions\n'
          f' Your method took {t1:.3f}s\n'
          f' The naive one took {t2:.3f}s')


if __name__ == '__main__':
    def f1():
        return []

    def f2():
        return []

    compare_function_performances(f1, f2, 1000)
